#!/usr/bin/perl -w
# test.pl - test program for _Console::Virtual
# v2003.0325 Chris Pressey, Cat's Eye Technologies

# Copyright (c)2000, Cat's Eye Technologies.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#   Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# 
#   Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# 
#   Neither the name of Cat's Eye Technologies nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission. 
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE. 

# uncomment any of these lines to test with other setups
# BEGIN { $_Console::Virtual::setup{input} = 'Screen'; $_Console::Virtual::setup{display} = 'Screen'; }
# BEGIN { $_Console::Virtual::setup{input} = 'POSIX'; $_Console::Virtual::setup{display} = 'Tput'; }
# BEGIN { $_Console::Virtual::setup{input} = 'Teletype'; $_Console::Virtual::setup{display} = 'Teletype'; }

use _Console::Virtual 2001.0127 qw(getkey display gotoxy clrscr clreol
                                   normal inverse bold update_display);

clrscr;
gotoxy(10,20);
display("Hello, world!");

gotoxy(20,10);
inverse();
display("Outta sight!");
normal();

# In this example, _Console::Virtual's functions have been imported into
# package main.
# Because of this, code which relied on the old package 'vC' still works.

::gotoxy(1,1);
::bold();
::display("Rock on!");
::normal();

# So does explicitly referencing the '_Console::Virtual' package.
# In fact, if you leave out the qw() list on 'use _Console::Virtual',
# you'll have to do it this way.

_Console::Virtual::gotoxy(3,3);
_Console::Virtual::update_display();

# getkey should automatically invoke update_display when appropriate.

display("Press a key: ");
$foo = getkey();
clrscr();
display("You pressed ", $foo, "!");
update_display;

### END of test.pl ###

